//-----------------------------------------------------------------------------
//  TimpyH_MSD_MMC.h
//-----------------------------------------------------------------------------
//
//  Copyright 2006, 2007 Chiaki Nakajima
//  Original copyright 2006 Silicon Laboratories, Inc.
//
//  Release 1.1
//      E\[X̐
//      EgpvZbTF340ɌC"__F340_VER__"`QƂ폜
//      Et@C"F34x_""TimpyH_"ɕύX
//
//  Release 1.0
//      ESiLabsUSB-MSD-RD(Release 1.1)ɁCTimpy Rev5.0pɑSʓIɕύX
//      ESDCCֈڐA
//      Esvȋ@\폜
//
//-----------------------------------------------------------------------------
//
//  Copyright 2006 Silicon Laboratories, Inc.
//  http://www.silabs.com
//
//  Release 1.1
//    -All changes by PKC
//    -09 JUN 2006
//    -No changes; incremented revision number to match project revision
//
//  Release 1.0
//    -Initial Release
//
//-----------------------------------------------------------------------------
//  Header File Preprocessor Directive
//-----------------------------------------------------------------------------

#ifndef _MSD_H_
#define _MSD_H_

#include "TimpyH_Common_Defs.h"

//-----------------------------------------------------------------------------
//  Structure Prototypes
//-----------------------------------------------------------------------------

typedef struct _CBW {
    ULONG dCBWSignature;
    ULONG dCBWTag;
    ULONG dCBWDataTransferLength;
    BYTE  bmCBWFlags;
    BYTE  bCBWLUN;
    BYTE  bCBWCBLength;
    BYTE  CBWCB[16];
} CBW;

typedef struct _CSW {
    ULONG dCSWSignature;
    ULONG dCSWTag;
    ULONG dCSWDataResidue;
    BYTE  bCSWStatus;
} CSW;

extern CBW __xdata cbw;
extern CSW __xdata csw;

//-----------------------------------------------------------------------------
//  Function Prototypes
//-----------------------------------------------------------------------------

void Msd_Step(void);

#endif

/* End of TimpyH_MSD_MMC.h */
