;------------------------------------------------------------------------------
;	TimpyH_MSD_Wait_Funcs.asm
;------------------------------------------------------------------------------
;
;	Copyright 2006, 2007 Chiaki Nakajima
;
;	Release 1.1
;	ESDCCŕsmɂȂĂԑ҂[`̎̂𕪗
;
;-------------------------------------------------------------------------------

.area 		WAIT_FUNCS 	(rel,con,code)

.globl 		_Wait_us_asm
.globl 		_Wait_ms_asm

;-------------------------------------------------------------------------------
; 	function Wait_us_asm
;
;	argument DPTR : ҂(usecP)
;
_Wait_us_asm:
		push		ACC
		;
		;					;҂ == 0ȂI
		mov		A, DPL
		orl		A, DPH
		jz		_WaitUsFinish			;҂ == 0ȂWv
		;
		;					;҂(L) != 0ȂDPH1ZĂ
		mov		A, DPL
		jz		_WaitUsLoop
		;
		inc		DPH				;DPH += 1
		;
_WaitUsLoop:						;҂ԃ[v
		;					;   = DPH * (DPL * 60 - 2) - 2 [cycles] ɂ蒲
		ljmp		01$				;5cycles
01$:		ljmp		02$				;5cycles
02$:		ljmp		03$				;5cycles
03$:		ljmp		04$				;5cycles
04$:		ljmp		05$				;5cycles
05$:		ljmp		06$				;5cycles
06$:		ljmp		07$				;5cycles
07$:		ljmp		08$				;5cycles
08$:		ljmp		09$				;5cycles
09$:		ljmp		10$				;5cycles
10$:		ljmp		11$				;5cycles
11$:		djnz		DPL, _WaitUsLoop		;3/5cycles
		;
		djnz		DPH, _WaitUsLoop		;3/5cycles
		;
_WaitUsFinish:						;I
		pop		ACC
		;
		ret					;^[
		;
;-------------------------------------------------------------------------------
; 	function Wait_ms_asm
;
;	argument DPTR : ҂(msecP)
;
_Wait_ms_asm:
		push		ACC
		;
		;					;҂ == 0ȂI
		mov		A, DPL
		orl		A, DPH
		jz		_WaitMsFinish			;҂ == 0ȂWv
		;
		;					;҂(L) != 0ȂDPH1ZĂ
		mov		A, DPL
		jz		_WaitMsLoop
		;
		inc		DPH				;DPH += 1
		;
_WaitMsLoop:						;҂ԃ[v
		push		DPH
		push		DPL
		mov		DPTR, #0d1000			;DPTR = 1000
		lcall		_Wait_us_asm			;1msec҂
		pop		DPL
		pop		DPH
		;
		djnz		DPL, _WaitMsLoop
		;
		djnz		DPH, _WaitMsLoop
		;
_WaitMsFinish:						;I
		pop		ACC
		;
		ret					;^[
		;
;------------------------------------------------------------------------------
;	End of TimpyH_MSD_Wait_Funcs.asm
;------------------------------------------------------------------------------
